#include "audio.h"

extern bool disable_audio_output ;
extern bool soundeffects_enabled ;
extern bool music_enabled ;

void Audio::Init ()
{
	if ( disable_audio_output == true )
	{
		audio_enabled = false ;
		soundeffects_enabled = false ;
		music_enabled = false ;
		
		fprintf ( stdout, "User disabled audio output completely.\n" ) ;
		
		return ;
	}
	
	// SDL
	SDL_Init ( SDL_INIT_AUDIO ) ;
	
	if ( Mix_OpenAudio ( AUDIO_RATE, AUDIO_FORMAT, 2, AUDIO_BUFFERS ) )
	{
		fprintf ( stdout, "!Warning! Unable to open audio: %s \n", SDL_GetError() ) ;
		fprintf ( stdout, "-- Going to continue without audio output.\n" ) ;
		audio_enabled = false ;
		soundeffects_enabled = false ;
		music_enabled = false ;
	} else {
		audio_enabled = true ;
		fprintf ( stdout, "Successfully initialized the audio device.\n" ) ;
		Mix_AllocateChannels ( AUDIO_CHANNELS ) ;
#if SDL_VERSION_ATLEAST(1, 2, 4)
		const SDL_version *version = Mix_Linked_Version () ;
		if ( version -> major >= 1 && version -> minor >= 2 && version -> patch >= 4 )
			fprintf ( stdout, "Panning for sound effects supported. :)\n\n" ) ;
		else
			fprintf ( stdout, "Panning for sound effects is not yet supported by your SDL_mixer library! :(\n" ) ;
#else
		fprintf ( stdout, "Panning for sound effects not supported.\n" ) ;
		fprintf ( stdout, "Please update your SDL to version 1.2.4 or newer! Sorry.\n\n" ) ;
#endif
	}
}

void Audio::Update ()
{
	if ( audio_enabled == false ) return ;
}

void Audio::Quit ()
{
	if ( audio_enabled == true )
	{
		Mix_CloseAudio () ;
		SDL_QuitSubSystem ( SDL_INIT_AUDIO ) ;
	}
	
	audio_enabled = false ;
}

