#include "audio_music.h"

extern bool music_enabled ;

bool IsFinished = true ;

void MusicDoneCallback_ ()
{
	IsFinished = true ;
}

Audio_Music::Audio_Music ()
{
	music = NULL ;
}

bool Audio_Music::LoadMusic ( char *filename )
{
	if ( music_enabled == FALSE ) return true ;
	
	if ( MusicFinished () == false && music != NULL )
	{
		fprintf ( stdout, "FIXME: please unload old music first!!!\n" ) ;
		return true ;
	}
	IsFinished = true ;
	
	music = NULL ;
	
	music = Mix_LoadMUS ( filename ) ;
	
	if ( ! music )
		fprintf ( stdout, "!Error! Couldn't load the music '%s': %s\n",
					filename, Mix_GetError () ) ;
	
	return music != NULL ;
}

void Audio_Music::PlayMusic ( int loops )
{
	if ( music && music_enabled )
	{
		//Mix_PlayMusic ( music, loops ) ;
		Mix_FadeInMusic ( music, loops, 500 ) ;
		Mix_HookMusicFinished ( MusicDoneCallback_ ) ;
		IsFinished = false ;
	}
}

void Audio_Music::PauseMusic ()
{
	if ( music && music_enabled )
	{
		Mix_PauseMusic () ;
		//fprintf ( stdout, "music paused.\n" ) ;
	}
}

void Audio_Music::UnPauseMusic ()
{
	if ( music && music_enabled )
	{
		Mix_ResumeMusic () ;
		//fprintf ( stdout, "music unpaused.\n" ) ;
	}
}

void Audio_Music::StopMusic ()
{
	if ( music && music_enabled )
	{
		Mix_FadeOutMusic ( 2000 ) ;
		//Mix_PauseMusic ( music ) ;
	}
}

bool Audio_Music::MusicFinished ()
{
	return IsFinished ;
}

bool Audio_Music::MusicPlaying ()
{
	return music_enabled ? Mix_PlayingMusic () : false ;
}

void Audio_Music::SetVolume ( int volume )
{
	if ( music && music_enabled )
		Mix_VolumeMusic ( volume ) ;
}

int Audio_Music::GetVolume ()
{
	if ( music && music_enabled )
		return Mix_VolumeMusic ( -1 ) ;
	else
		return 0 ;
}

void Audio_Music::UnloadMusic ()
{
	if ( music && music_enabled )
	{
		UnPauseMusic () ;
		StopMusic () ;
		Mix_HaltMusic () ;
		Mix_FreeMusic ( music ) ;
		Mix_SetMusicCMD ( NULL ) ;
		music = NULL ;
		IsFinished = true ;
	}
}
