#include "c1_layer.h"

extern FileCache file_cache ;
#include "video.h"
extern Video video ;

KrImNode *video_base_node = NULL ;

void C1_Layer::Init ()
{
	/*video_base_node = new KrImNode () ;
	video_base_node -> SetPos ( 0, 0 ) ;
	video . GetEngine() -> Tree () -> AddNode ( NULL, video_base_node ) ;
	video_base_node -> SetScale ( 1.00, 1.00 ) ;*/
	
	if ( ! video . GetC1ModeActive () )
	{
		vault = NULL ;
		left_layer = NULL ;
		right_layer = NULL ;
		video_base_node = NULL ;
		return ;
	}
	
	vault = (KrResourceVault*) file_cache . CachedLoad ( "vault",
													"gfx/misc.dat" ) ;
	char layer_name [] = "c1_layer" ;
	KrSpriteResource *resource = vault -> GetSpriteResource ( layer_name ) ;
	if ( resource == NULL )
	{
		fprintf ( stdout, "ERROR: Sprite not found '%s'\n", layer_name ) ;
		exit ( 1 ) ;
	}
	
	left_layer  = new KrSprite ( resource ) ;
	right_layer = new KrSprite ( resource ) ;
	
	KrRect rect ;
	left_layer->QueryBoundingBox ( &rect ) ;
	int w = rect.Width() ;
	//int h = rect.Height() ;
	
	left_layer  -> SetPos ( 0, 0 ) ;
	right_layer -> SetPos ( video . GetScreenWidth () - w, 0 ) ;
	
	video . GetEngine () -> Tree () -> AddNode ( 0, left_layer ) ;
	video . GetEngine () -> Tree () -> AddNode ( 0, right_layer ) ;
	
	left_layer  -> SetZDepth ( 500 ) ;
	right_layer -> SetZDepth ( 500 ) ;
	
	// init video base node
	int t_x = 0, t_y = 0 ;
	t_x = ( 1024 - 640 ) / 2 ; // vaio c1-mode !
	video_base_node = new KrImNode () ;
	video_base_node -> SetPos ( t_x, t_y ) ;
	video . GetEngine() -> Tree () -> AddNode ( NULL, video_base_node ) ;

	Show () ;
}

void C1_Layer::Show ()
{
	if ( left_layer )
		left_layer  -> SetVisible ( TRUE ) ;
	if ( right_layer )
		right_layer -> SetVisible ( TRUE ) ;
}

void C1_Layer::Hide ()
{
	if ( left_layer )
		left_layer  -> SetVisible ( FALSE ) ;
	if ( right_layer )
		right_layer -> SetVisible ( FALSE ) ;
}

void C1_Layer::Quit ()
{
	if ( left_layer )
	{
		video . GetEngine () -> Tree () -> DeleteNode ( left_layer ) ;
		left_layer = NULL ;
	}
	if ( right_layer )
	{
		video . GetEngine () -> Tree () -> DeleteNode ( right_layer ) ;
		right_layer = NULL ;
	}
	if ( video_base_node )
	{
		video . GetEngine () -> Tree () -> DeleteNode ( video_base_node ) ;
		video_base_node = NULL ;
	}
	if ( vault )
	{
		file_cache . FreeCachedData ( "vault", vault ) ;
		vault = NULL ;
	}
}
