#include "hid.h"

// initialize everyone...

void HID::Init ()
{
	keyboard . Init () ;
	joystick . Init () ;
}

// is this a keyboard event?

bool HID::IsKeyboardEvent ( SDL_Event event )
{
	if (	event . type == SDL_KEYDOWN	||
			event . type == SDL_KEYUP	)
		return TRUE ;
	else
		return FALSE ;		
}

// is this a joystick event?

bool HID::IsJoystickEvent ( SDL_Event event )
{
	if (	event . type == SDL_JOYAXISMOTION	||
			event . type == SDL_JOYBALLMOTION	||
			event . type == SDL_JOYHATMOTION	||
			event . type == SDL_JOYBUTTONDOWN	||
			event . type == SDL_JOYBUTTONUP		)
		return TRUE ;
	else
		return FALSE ;		
}

// is there an interesting event?! :)

bool HID::EventFound ( SDL_Event event )
{
	if ( IsKeyboardEvent ( event ) || IsJoystickEvent ( event ) )
		return TRUE ;
	else
		return FALSE ;
}

// left player pressed something...

bool HID::Left_up_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Left_up_key () ) ||
			( IsJoystickEvent ( event ) && 
			  joystick . Left_up_pressed ( event ) ) 
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_down_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Left_down_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_down_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_left_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Left_left_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_left_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_right_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Left_right_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_right_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_fire_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Left_fire_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_fire_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

// left player released something...

bool HID::Left_up_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Left_up_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_up_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_down_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Left_down_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_down_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_left_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Left_left_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_left_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_right_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Left_right_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_right_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Left_fire_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Left_fire_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Left_fire_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

// right player pressed something...

bool HID::Right_up_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Right_up_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_up_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_down_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Right_down_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_down_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_left_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Right_left_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_left_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_right_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Right_right_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_right_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_fire_pressed ( SDL_Event event )
{
	if (	( event . type == SDL_KEYDOWN &&
			  event . key . keysym . sym == keyboard . Right_fire_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_fire_pressed ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

// right player released something...

bool HID::Right_up_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Right_up_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_up_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_down_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Right_down_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_down_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_left_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Right_left_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_left_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_right_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Right_right_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_right_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

bool HID::Right_fire_released ( SDL_Event event )
{
	if (	( event . type == SDL_KEYUP &&
			  event . key . keysym . sym == keyboard . Right_fire_key () ) ||
			( IsJoystickEvent ( event ) &&
			  joystick . Right_fire_released ( event ) )
		)
		return TRUE ;
	else
		return FALSE ;
}

// :(

void HID::Quit ()
{
	keyboard . Quit () ;
	joystick . Quit () ;
}

