#include "mouse_cursor.h"

extern FileCache file_cache ;

#include "c1_layer.h"
extern KrImNode *video_base_node ;

void MouseCursor::Init ()
{
	mouse_vault = (KrResourceVault*) file_cache . CachedLoad ( "vault",
															"gfx/misc.dat" ) ;
	
	KrImNode *real_background = 0 ;
	if ( video_base_node != NULL )
		real_background = video_base_node -> Parent () ;
	
	mouse_cursor  = new Sprite () ;
	mouse_cursor -> Init ( mouse_vault, "mouse_normal", real_background ) ;
	mouse_cursor -> SetXY ( 0, 0 ) ;
	mouse_cursor -> SetZ  ( 1000 ) ;
	mouse_cursor -> SetAlpha ( 0 ) ;
	mouse_cursor -> SetDestAlpha ( 192 ) ;
	mouse_cursor -> Twinkling ( true, 16 ) ;
	mouse_cursor -> SetRainCreationArea ( 0, 10, 10, 4 ) ;
}

void MouseCursor::Draw ()
{
	mouse_cursor -> Draw () ;
}

void MouseCursor::SetXY ( int x, int y )
{
	mouse_cursor -> SetXY ( x, y ) ;
}

int  MouseCursor::X ()
{
	return mouse_cursor -> GetXPos () ;
}

int  MouseCursor::Y ()
{
	return mouse_cursor -> GetYPos () ;
}

void MouseCursor::Hide ()
{
	mouse_cursor -> GetSprite () -> SetVisible ( false ) ;
}

void MouseCursor::Show ()
{
	mouse_cursor -> GetSprite () -> SetVisible ( true ) ;
}

void MouseCursor::Quit ()
{
	mouse_cursor -> SetDestAlpha ( 0 ) ;
}

void MouseCursor::Free ()
{
	mouse_cursor -> Free () ;
	delete mouse_cursor ;
	file_cache . FreeCachedData ( "vault", mouse_vault ) ;
}
