#include "osd.h"

extern FileCache file_cache ;

#include "video.h"
extern Video video ;

void OSD::Init ()
{
	engine = video . GetEngine () ;

	fontVault = (KrResourceVault*) file_cache . CachedLoad ( "vault",
														"gfx/fonts_para.dat" ) ;
	font = fontVault->GetFontResource ( "parafont" ) ;
	GLASSERT ( font ) ;
	textBox = new KrTextBox ( font, video . GetScreenWidth () - 10, 50, 0, KrTextBox::RIGHT ) ;
	
	textBox -> SetTextChar ( "", 0 ) ;
	
	engine->Tree()->AddNode ( 0, textBox ) ;
	textBox -> SetZDepth ( 1000 ) ;
	textBox -> SetPos ( 5, 5 ) ;
	
	current_ticks =	old_ticks = SDL_GetTicks () ;
	
	hold = false ;
}

void OSD::DisplayMessage ( char *message )
{
	if ( hold == false )
	{
		textBox -> SetTextChar ( message, 0 ) ;
		old_ticks = SDL_GetTicks () + 1000 ;
	}
}

void OSD::HoldMessage ()
{
	hold = true ;
}

void OSD::UnholdMessage ()
{
	hold = false ;
	old_ticks = SDL_GetTicks () + 1000 ;
}

bool OSD::MessageIsHold ()
{
	return hold ;
}

void OSD::Draw ()
{
	current_ticks = SDL_GetTicks () ;
	if ( current_ticks > old_ticks + 1000 && hold == false )
	{	
		textBox -> SetTextChar ( "", 0 ) ;
		old_ticks = current_ticks ;
	}
}

void OSD::Quit ()
{
	engine->Tree()->DeleteNode ( textBox ) ;
	file_cache . FreeCachedData ( "vault", fontVault ) ;
}
