#include "title.h"

extern char rc_dir[], pax_dir[] ;

extern char pkg_filename[] ;

extern bool screen_saver_mode ;

extern FileCache file_cache ;

#include "video.h"
extern Video video ;

#include "gamescreen.h"
extern PaxList *pax_list ;
extern int next_game_screen ;

#include "hid.h"
extern HID hid ;

void Title::Init ( char *new_left_levelfname, char *new_right_levelfname )
{
	using_opengl = video . GetUsingOpenGL () ;
	left_levelfname  = new_left_levelfname ;
	right_levelfname = new_right_levelfname ;
	
	//fprintf ( stdout, "init titlescreen\n" ) ;
	
	///
	
	pax = new Pax () ;
	pax -> Init ( "title" ) ;
	
	///

	background.Init ( pax ) ;
	
	logo_gem = (Sprite*) pax -> GetObjectFromList ( "logo_gem" ) -> data ;
	logo_hunters = (Sprite*) pax -> GetObjectFromList ( "logo_hunters" ) -> data ;

	MiscVault = (KrResourceVault*) file_cache . CachedLoad ( "vault", "gfx/misc.dat" ) ;
	MenuVault = (KrResourceVault*) file_cache . CachedLoad ( "vault", "gfx/menu.dat" ) ;

	if ( screen_saver_mode )
		background . ToggleMusic () ;

	paused = FALSE ;
	
	quit = FALSE ;
	quit_state = FALSE ;
	
	activate_sound . LoadSound ( "sfx/disable.wav" ) ;
	
	int y_pos = 480 * 3 / 4 - 60 ;
	
	dark_block  = new Sprite () ;
	if ( using_opengl )
		dark_block -> Init ( MiscVault, "dark_block" ) ;
	else
		dark_block -> Init ( MiscVault, "dummy" ) ;
	dark_block -> SetXY ( 0, y_pos - 14 - 10 ) ;
	dark_block -> SetAlpha ( 0 ) ;
	dark_block -> SetDestAlpha ( 255 ) ;
	
	arrow_left   = new Sprite () ;
	arrow_left  -> Init ( MiscVault, "arrow_left", dark_block -> GetSprite () ) ;
	arrow_left  -> SetDelays ( 5 ) ;
	arrow_left  -> SetXY ( 40 + 160, 14 + 45 ) ;
	arrow_left  -> SetAlpha ( 0 ) ;
	arrow_left  -> SetDestAlpha ( 0 ) ;
	arrow_left  -> SetZ ( 50 ) ;
	arrow_left  -> SetFadeSpeed ( 34 ) ;
	arrow_left	-> SetXSpeed ( 20 ) ;
	arrow_right  = new Sprite () ;
	arrow_right -> Init ( MiscVault, "arrow_right", dark_block -> GetSprite () ) ;
	arrow_right -> SetDelays ( 5 ) ;
	arrow_right -> SetXY ( 640 - 60 - 160, 14 + 45 ) ;
	arrow_right -> SetAlpha ( 0 ) ;
	arrow_right -> SetDestAlpha ( 255 ) ;
	arrow_right -> SetZ ( 50 ) ;
	arrow_right -> SetFadeSpeed ( 34 ) ;
	arrow_right	-> SetXSpeed ( 20 ) ;
	arrow_up     = new Sprite () ;
	arrow_up    -> Init ( MiscVault, "arrow_up", dark_block -> GetSprite () ) ;
	arrow_up    -> SetDelays ( 5 ) ;
	arrow_up    -> SetXY ( 320 - 18 + 2, 14 - 20 + 30 ) ;
	arrow_up    -> SetAlpha ( 0 ) ;
	arrow_up    -> SetDestAlpha ( 0 ) ;
	arrow_up    -> SetZ ( 50 ) ;
	arrow_up    -> SetFadeSpeed ( 34 ) ;
	arrow_down   = new Sprite () ;
	arrow_down  -> Init ( MiscVault, "arrow_down", dark_block -> GetSprite () ) ;
	arrow_down  -> SetDelays ( 5 ) ;
	arrow_down  -> SetXY ( 320 - 18 + 2, 14 + 90 + 30 - 30 ) ;
	arrow_down  -> SetAlpha ( 0 ) ;
	arrow_down  -> SetDestAlpha ( 255 ) ;
	arrow_down  -> SetZ ( 50 ) ;
	arrow_down  -> SetFadeSpeed ( 34 ) ;
	
	start_game_dummy  = new Sprite () ;
	start_game_dummy -> Init ( MiscVault, "dummy", dark_block -> GetSprite () ) ;
	start_game_dummy -> SetAlpha ( 0 ) ;
	start_game_dummy -> SetDestAlpha ( 0 ) ;
	start_game_dummy -> SetXY ( 0, 14 ) ;
	start_game_dummy -> SetFadeSpeed ( 34 ) ;
	start_game_dummy -> SetStopSound ( NULL, 0 ) ;
	start_game_dummy -> SetMoveSound ( "sfx/malus.wav", 128 ) ;
	start_type_dummy  = new Sprite () ;
	start_type_dummy -> Init ( MiscVault, "dummy", dark_block -> GetSprite () ) ;
	start_type_dummy -> SetAlpha ( 0 ) ;
	start_type_dummy -> SetDestAlpha ( 255 ) ;
	start_type_dummy -> SetXY ( 0, 14 + 40 ) ;
	start_type_dummy -> SetFadeSpeed ( 34 ) ;
	start_type_dummy -> SetStopSound ( NULL, 0 ) ;
	start_type_dummy -> SetMoveSound ( "sfx/malus.wav", 128 ) ;
	network_dummy     = new Sprite () ;
	network_dummy    -> Init ( MiscVault, "dummy", dark_block -> GetSprite () ) ;
	network_dummy    -> SetAlpha ( 0 ) ;
	network_dummy    -> SetDestAlpha ( 0 ) ;
	network_dummy    -> SetXY ( 0, 14 + 40 ) ;
	network_dummy    -> SetFadeSpeed ( 34 ) ;
	network_dummy    -> SetStopSound ( NULL, 0 ) ;
	network_dummy    -> SetMoveSound ( "sfx/malus.wav", 128 ) ;
	editor_dummy      = new Sprite () ;
	editor_dummy     -> Init ( MiscVault, "dummy", dark_block -> GetSprite () ) ;
	editor_dummy     -> SetAlpha ( 0 ) ;
	editor_dummy     -> SetDestAlpha ( 0 ) ;
	editor_dummy     -> SetXY ( 0, 14 + 40 ) ;
	editor_dummy     -> SetFadeSpeed ( 34 ) ;
	editor_dummy     -> SetStopSound ( NULL, 0 ) ;
	editor_dummy     -> SetMoveSound ( "sfx/malus.wav", 128 ) ;
	options_dummy     = new Sprite () ;
	options_dummy    -> Init ( MiscVault, "dummy", dark_block -> GetSprite () ) ;
	options_dummy    -> SetAlpha ( 0 ) ;
	options_dummy    -> SetDestAlpha ( 0 ) ;
	options_dummy    -> SetXY ( 0, 14 + 40 ) ;
	options_dummy    -> SetFadeSpeed ( 34 ) ;
	options_dummy    -> SetStopSound ( NULL, 0 ) ;
	options_dummy    -> SetMoveSound ( "sfx/malus.wav", 128 ) ;
	quit_dummy        = new Sprite () ;
	quit_dummy       -> Init ( MiscVault, "dummy", dark_block -> GetSprite () ) ;
	quit_dummy       -> SetAlpha ( 0 ) ;
	quit_dummy       -> SetDestAlpha ( 0 ) ;
	quit_dummy       -> SetXY ( 0, 14 + 40 ) ;
	quit_dummy       -> SetFadeSpeed ( 34 ) ;
	quit_dummy       -> SetStopSound ( NULL, 0 ) ;
	quit_dummy       -> SetMoveSound ( "sfx/malus.wav", 128 ) ;

	new_game_text = new Sprite () ;
	new_game_text -> Init ( MenuVault, "new_game", start_type_dummy -> GetSprite () ) ;
	new_game_text -> SetX_Center ( video . GetScreenX () ) ;
	new_game_text -> SetFadeSpeed ( 34 ) ;
	continue_last_game_text = new Sprite () ;
	continue_last_game_text -> Init ( MenuVault, "continue_last_game", start_type_dummy -> GetSprite () ) ;
	continue_last_game_text -> SetX_Center ( video . GetScreenX () ) ;
	continue_last_game_text -> SetAlpha ( 0 ) ;
	continue_last_game_text -> SetFadeSpeed ( 34 ) ;
	continue_last_game_text -> Darken ( 128 ) ;
	load_game_text = new Sprite () ;
	load_game_text -> Init ( MenuVault, "load_game", start_type_dummy -> GetSprite () ) ;
	load_game_text -> SetX_Center ( video . GetScreenX () ) ;
	load_game_text -> SetAlpha ( 0 ) ;
	load_game_text -> SetFadeSpeed ( 34 ) ;
	load_game_text -> Darken ( 128 ) ;
	erase_game_text = new Sprite () ;
	erase_game_text -> Init ( MenuVault, "erase_game", start_type_dummy -> GetSprite () ) ;
	erase_game_text -> SetX_Center ( video . GetScreenX () ) ;
	erase_game_text -> SetAlpha ( 0 ) ;
	erase_game_text -> SetFadeSpeed ( 34 ) ;
	erase_game_text -> Darken ( 128 ) ;
	game_type_cur_item   = 0 ;
	game_type_item_count = 4 ;
	game_type_last_item  = 0 ;
	
	network_text = new Sprite () ;
	network_text -> Init ( MenuVault, "network_gaming", network_dummy -> GetSprite () ) ;
	network_text -> SetX_Center ( video . GetScreenX () ) ;
#ifndef __NETWORK_SUPPORT__
	network_text -> Darken ( 128 ) ;
#endif
	
	level_editor_text = new Sprite () ;
	level_editor_text -> Init ( MenuVault, "level_editor", editor_dummy -> GetSprite () ) ;
	level_editor_text -> SetX_Center ( video . GetScreenX () ) ;
	level_editor_text -> Darken ( 128 ) ;
	
	options_text = new Sprite () ;
	options_text -> Init ( MenuVault, "options", options_dummy -> GetSprite () ) ;
	options_text -> SetX_Center ( video . GetScreenX () ) ;
	options_text -> Darken ( 128 ) ;
	
	quit_text = new Sprite () ;
	quit_text -> Init ( MenuVault, "quit", quit_dummy -> GetSprite () ) ;
	quit_text -> SetX_Center ( video . GetScreenX () ) ;

	nopax_text = new Sprite () ;
	nopax_text -> Init ( MiscVault, "dummy", quit_dummy -> GetSprite () ) ;
	nopax_text -> SetXY ( video . GetScreenX (), -30 ) ;
	nopax_text -> SetXSpeed ( 2 ) ;
	nopax_text -> SetYSpeed ( 2 ) ;
	nopax_text -> SetXYSpeed ( 2 ) ;
	nopax_text -> SetAlpha ( 0 ) ;
	nopax_text_direction = -1 ;
	
	nopax_text_part1 = new Sprite () ;
	nopax_text_part1 -> Init ( MenuVault, "nopax", nopax_text -> GetSprite () ) ;
	nopax_text_part1 -> SetXY ( 0, 0 ) ;
	nopax_text_part1 -> SetFrames ( 0, 0, 1, false, true ) ;
	nopax_text_part2 = new Sprite () ;
	nopax_text_part2 -> Init ( MenuVault, "nopax", nopax_text -> GetSprite () ) ;
	nopax_text_part2 -> SetXY ( 1000, 0 ) ;
	nopax_text_part2 -> SetFrames ( 1, 1, 1, false, true ) ;
	nopax_text_part3 = new Sprite () ;
	nopax_text_part3 -> Init ( MenuVault, "nopax", nopax_text -> GetSprite () ) ;
	nopax_text_part3 -> SetXY ( 2000, 0 ) ;
	nopax_text_part3 -> SetFrames ( 2, 2, 1, false, true ) ;
	nopax_text_part4 = new Sprite () ;
	nopax_text_part4 -> Init ( MenuVault, "nopax", nopax_text -> GetSprite () ) ;
	nopax_text_part4 -> SetXY ( 3000, 0 ) ;
	nopax_text_part4 -> SetFrames ( 3, 3, 1, false, true ) ;
	nopax_text_part5 = new Sprite () ;
	nopax_text_part5 -> Init ( MenuVault, "nopax", nopax_text -> GetSprite () ) ;
	nopax_text_part5 -> SetXY ( 4000, 0 ) ;
	nopax_text_part5 -> SetFrames ( 4, 4, 1, false, true ) ;

	menu_line = ML_START_TYPE ;
	menu_line_max = ML_COUNT ;
	
	continue_last_game = false ; // <- default
	// now check if there's an autosave state...
	char autosave_state [ 4096 ] ;
	sprintf ( autosave_state, "%s/autosave.state", rc_dir ) ;
	FILE *stream = fopen ( autosave_state, "r" ) ;
	if ( stream )
	{
		char pax_string [ 4096 ] ;
		sprintf ( pax_string, "%s", "" ) ;
		
		fgets ( pax_string, 4096, stream ) ;
		
		struct stat buf ;
		if ( stat ( pax_string, &buf ) == 0 )
		{
			continue_last_game_text -> Darken ( 0 ) ;
			continue_last_game = true ;
			game_type_cur_item = 1 ;
		}
		
		fclose ( stream ) ;
	}
	
	// now search for pax...
	pax_list_offset = pax_list_old_offset = 0 ;
	pax_list_cur_item = 0 ;
	pax_list_last_item = -1 ;
	pax_list -> AttachListToNode ( start_game_dummy -> GetSprite (),
									pax_list -> PLB_WHITE ) ;
	for ( unsigned  int i = 0 ; i < pax_list -> Count () ; i++ )
	{
		// bubble-like-anim control-values...
		pax_item_addon *pia = (pax_item_addon*) malloc ( sizeof (pax_item_addon) ) ;
		pia -> c_pos =  0 ; pia -> c_max = FRAMERATE / 2 ;
		pia -> d_pos =  0 ; pia -> d_max =  1 ;
		KrSprite *sprite = pax_list -> Item ( i ) -> node -> GetSprite () ;
		pia -> scale_x = sprite -> XScale () . ToDouble () ;
		pia -> scale_y = sprite -> YScale () . ToDouble () ;
		pax_list -> Item ( i ) -> user_data = pia ;
		
		// set position of pax element
		int group_count = ( i - ( i % 3 ) ) / 3 ;
		int x_pos = group_count * video . GetScreenX () ;
		x_pos += 640 * ( i - group_count * 3 ) / 4 + 640 / 8 ;
		int y_pos = 0 ;
		pax_list -> Item ( i ) -> node -> SetXY ( x_pos, y_pos ) ;
	}
	if ( pax_list -> FindPaxElement ( pkg_filename ) > -1 )
		pax_list_cur_item = pax_list -> FindPaxElement ( pkg_filename ) ;
	EnablePaxElement ( pax_list_cur_item ) ;
	//
	
	if ( pax_list -> Count () < 1 )
	{
		new_game_text -> SetDestDarken ( 128 ) ;
		continue_last_game_text -> SetDestDarken ( 128 ) ;
		continue_last_game = false ;
		game_type_cur_item = 0 ;
		menu_line = ML_QUIT ;
		arrow_up         -> SetDestAlpha (   0 ) ;
		arrow_down       -> SetDestAlpha (   0 ) ;
		arrow_left       -> SetDestAlpha (   0 ) ;
		arrow_right      -> SetDestAlpha (   0 ) ;
		start_type_dummy -> SetDestAlpha (   0 ) ;
		quit_dummy       -> SetDestAlpha ( 255 ) ;
		quit_text        -> SetAlpha     (   0 ) ;
		nopax_text       -> SetDestAlpha ( 255 ) ;
	}
	else
	{
		char text [ 256 ] ;
		sprintf ( text, "welcome!" ) ;
		video . DisplayOSDMessage ( text ) ;
	}	
	
	//fprintf ( stdout, "done.\n" ) ;
}

void Title::ProcessEvents ( SDL_Event event )
{
	switch ( event.type )
	{
		case SDL_KEYDOWN:
		{
			SDLKey sym = event.key.keysym.sym ;
			// toggle music on/off
			if ( sym == SDLK_F2 )
				background . ToggleMusic () ;

		}
		break ;

		default:
		break ;
	}
	
	if ( hid.EventFound ( event ) && background.PlayfieldIsReady () &&
			paused == false && quit == false /*&&
			arrow_left -> SlideFinished () && arrow_right -> SlideFinished () &&
			arrow_up   -> SlideFinished () && arrow_down  -> SlideFinished ()*/ )
	{
		// start game!
		if ( hid.Left_fire_pressed ( event ) ||
				hid.Right_fire_pressed ( event ) )
		{
			switch ( menu_line )
			{
				case ML_START_GAME:
				{	// choose theme and start game
					if ( pax_list -> Count () )
					{
						next_game_screen = GS_GAME ;
						continue_last_game = false ;
						Quit () ;
					}
				}
				break ;
				case ML_START_TYPE:
				{	// new game / continue / load game
					switch ( game_type_cur_item )
					{
						case 0:
						{	// start new game but first choose theme
							if ( pax_list -> Count () )
							{
								arrow_up         -> SetDestAlpha (   0 ) ;
								arrow_down       -> SetDestAlpha ( 255 ) ;
								arrow_up         -> SetDestXY (	arrow_up   -> GetXPos (),
																arrow_up   -> GetYPos () - 30 ) ;
								arrow_down       -> SetDestXY (	arrow_down -> GetXPos (),
																arrow_down -> GetYPos () + 30 ) ;
								arrow_left       -> SetDestXY (	arrow_left  -> GetXPos () - 160,
																arrow_left  -> GetYPos () ) ;
								arrow_right      -> SetDestXY (	arrow_right -> GetXPos () + 160,
																arrow_right -> GetYPos () ) ;
								start_game_dummy -> SetDestAlpha ( 255 ) ;
								start_type_dummy -> SetDestAlpha (   0 ) ;
								ShowPaxList () ;
								menu_line = ML_START_GAME ;
							}
						}
						break ;
						case 1:
						{	// if possible continue last game...
							if ( continue_last_game == true )
							{
								next_game_screen = GS_GAME ;
								Quit () ;
							}
						}
						break ;
						case 2:
						{
							
						}
						break ;
						case 3:
						{
							
						}
						break ;
					}
				}
				break ;
				case ML_NETWORK:
				{	// network gaming
#ifdef __NETWORK_SUPPORT__
					next_game_screen = GS_NETWORK ;
					continue_last_game = false ;
					Quit () ;
#endif
				}
				break ;
				case ML_EDITOR:
				{	// level editor
					
				}
				break ;
				case ML_OPTIONS:
				{	// options
					
				}
				break ;
				case ML_QUIT:
				{	// quit
					next_game_screen = GS_NONE ;
					Quit () ;
				}
				break ;
			}
		}
		else if ( hid.Left_left_pressed ( event ) ||
				hid.Right_left_pressed ( event ) )
		{
			switch ( menu_line )
			{
				case ML_START_GAME:
				{	// browse to previous pax
					if ( pax_list_cur_item > 0 )
						pax_list_cur_item-- ;
				}
				break ;
				case ML_START_TYPE:
				{	// browse to previous item
					if ( game_type_cur_item > 0 )
						game_type_cur_item-- ;
				}
				break ;
			}
		}
		else if ( hid.Left_right_pressed ( event ) ||
				hid.Right_right_pressed ( event ) )
		{
			switch ( menu_line )
			{
				case ML_START_GAME:
				{	// browse to next pax
				if ( (unsigned int) pax_list_cur_item < pax_list -> Count () - 1 )
					pax_list_cur_item++ ;
				}
				break ;
				case ML_START_TYPE:
				{	// browse to next item
					if ( game_type_cur_item < game_type_item_count - 1 )
						game_type_cur_item++ ;
				}
				break ;
			}
		}
		else if ( menu_line > 1 && pax_list -> Count () &&
				( hid.Left_up_pressed ( event ) ||
				  hid.Right_up_pressed ( event ) ) )
		{
			switch ( menu_line )
			{
				case ML_NETWORK:
				{
					arrow_up         -> SetDestAlpha (   0 ) ;
					arrow_down       -> SetDestAlpha ( 255 ) ;
					start_type_dummy -> SetDestAlpha ( 255 ) ;
					network_dummy    -> SetDestAlpha (   0 ) ;
					if ( game_type_cur_item > 0 )
						arrow_left  -> SetDestAlpha ( 255 ) ;
					if ( game_type_cur_item < game_type_item_count - 1 )
						arrow_right -> SetDestAlpha ( 255 ) ;
				}
				break ;
				case ML_EDITOR:
				{
					arrow_up         -> SetDestAlpha ( 255 ) ;
					arrow_down       -> SetDestAlpha ( 255 ) ;
					network_dummy    -> SetDestAlpha ( 255 ) ;
					editor_dummy     -> SetDestAlpha (   0 ) ;
				}
				break ;
				case ML_OPTIONS:
				{
					arrow_up         -> SetDestAlpha ( 255 ) ;
					arrow_down       -> SetDestAlpha ( 255 ) ;
					editor_dummy     -> SetDestAlpha ( 255 ) ;
					options_dummy    -> SetDestAlpha (   0 ) ;
				}
				break ;
				case ML_QUIT:
				{
					arrow_up         -> SetDestAlpha ( 255 ) ;
					arrow_down       -> SetDestAlpha ( 255 ) ;
					options_dummy    -> SetDestAlpha ( 255 ) ;
					quit_dummy       -> SetDestAlpha (   0 ) ;
				}
			}
			
			menu_line-- ;
			activate_sound . PlaySound () ;
		}
		else if ( menu_line < ML_COUNT - 1 && pax_list -> Count () &&
				( hid.Left_down_pressed ( event ) ||
				  hid.Right_down_pressed ( event ) ) )
		{
			switch ( menu_line )
			{
				case ML_START_GAME:
				{
					arrow_up         -> SetDestAlpha (   0 ) ;
					arrow_down       -> SetDestAlpha ( 255 ) ;
					arrow_up         -> SetDestXY (	arrow_up   -> GetXPos (),
													arrow_up   -> GetYPos () + 30 ) ;
					arrow_down       -> SetDestXY (	arrow_down -> GetXPos (),
													arrow_down -> GetYPos () - 30 ) ;
					arrow_left       -> SetDestXY (	arrow_left  -> GetXPos () + 160,
													arrow_left  -> GetYPos () ) ;
					arrow_right      -> SetDestXY (	arrow_right -> GetXPos () - 160,
													arrow_right -> GetYPos () ) ;
					start_game_dummy -> SetDestAlpha (   0 ) ;
					start_type_dummy -> SetDestAlpha ( 255 ) ;
					HidePaxList () ;
					if ( game_type_cur_item > 0 )
						arrow_left  -> SetDestAlpha ( 255 ) ;
					if ( game_type_cur_item < game_type_item_count )
						arrow_right -> SetDestAlpha ( 255 ) ;
				}
				break ;
				case ML_START_TYPE:
				{
					arrow_up         -> SetDestAlpha ( 255 ) ;
					arrow_down       -> SetDestAlpha ( 255 ) ;
					start_type_dummy -> SetDestAlpha (   0 ) ;
					network_dummy    -> SetDestAlpha ( 255 ) ;
					arrow_left       -> SetDestAlpha ( 0 ) ;
					arrow_right      -> SetDestAlpha ( 0 ) ;
				}
				break ;
				case ML_NETWORK:
				{
					arrow_up      -> SetDestAlpha ( 255 ) ;
					arrow_down    -> SetDestAlpha ( 255 ) ;
					network_dummy -> SetDestAlpha (   0 ) ;
					editor_dummy  -> SetDestAlpha ( 255 ) ;
				}
				break ;
				case ML_EDITOR:
				{
					arrow_up      -> SetDestAlpha ( 255 ) ;
					arrow_down    -> SetDestAlpha ( 255 ) ;
					editor_dummy  -> SetDestAlpha (   0 ) ;
					options_dummy -> SetDestAlpha ( 255 ) ;
				}
				break ;
				case ML_OPTIONS:
				{
					arrow_up      -> SetDestAlpha ( 255 ) ;
					arrow_down    -> SetDestAlpha (   0 ) ;
					options_dummy -> SetDestAlpha (   0 ) ;
					quit_dummy    -> SetDestAlpha ( 255 ) ;
				}
				break ;
			}
			
			menu_line++ ;
			activate_sound . PlaySound () ;
		}
	}
}

void Title::Pause ()
{
	background.Pause () ;
	paused = TRUE ;
}

void Title::UnPause ()
{
	background.UnPause () ;
	paused = FALSE ;
}

void Title::Draw ()
{
	if ( game_type_cur_item != game_type_last_item )
	{
		Sprite *sprite ;
		switch ( game_type_last_item )
		{
			case  0: sprite = new_game_text           ; break ;
			case  1: sprite = continue_last_game_text ; break ;
			case  2: sprite = load_game_text          ; break ;
			case  3: sprite = erase_game_text         ; break ;
			default: sprite = new_game_text           ; break ;
		}
		sprite -> SetDestAlpha ( 0 ) ;
		
		switch ( game_type_cur_item )
		{
			case  0: sprite = new_game_text           ; break ;
			case  1: sprite = continue_last_game_text ; break ;
			case  2: sprite = load_game_text          ; break ;
			case  3: sprite = erase_game_text         ; break ;
			default: sprite = new_game_text           ; break ;
		}
		sprite -> SetDestAlpha ( 255 ) ;
		
		if ( menu_line == ML_START_TYPE )
		{
			if ( game_type_cur_item != game_type_last_item )
				activate_sound . PlaySound () ;
			
			if ( game_type_cur_item > 0 )
				arrow_left -> SetDestAlpha ( 255 ) ;
			else
				arrow_left -> SetDestAlpha (   0 ) ;
			if ( game_type_cur_item < game_type_item_count - 1 )
				arrow_right -> SetDestAlpha ( 255 ) ;
			else
				arrow_right -> SetDestAlpha (   0 ) ;
		}
		
		if ( game_type_cur_item == 1 && game_type_last_item != 1 )
		{
			arrow_left       -> SetDestXY (	arrow_left  -> GetXPos () - 60,
											arrow_left  -> GetYPos () ) ;
			arrow_right      -> SetDestXY (	arrow_right -> GetXPos () + 60,
											arrow_right -> GetYPos () ) ;
		}
		if ( game_type_cur_item != 1 && game_type_last_item == 1 )
		{
			arrow_left       -> SetDestXY (	arrow_left  -> GetXPos () + 60,
											arrow_left  -> GetYPos () ) ;
			arrow_right      -> SetDestXY (	arrow_right -> GetXPos () - 60,
											arrow_right -> GetYPos () ) ;
		}
		
		game_type_last_item = game_type_cur_item ;
	}
	
	background.Draw () ;
	if ( background.PlayfieldIsReady () && screen_saver_mode == FALSE /*&&
			logo_gem -> SlideFinished () && logo_hunters -> SlideFinished ()*/ )
	{
		dark_block -> Draw () ;
		
		arrow_left  -> Draw () ;
		arrow_right -> Draw () ;
		arrow_up    -> Draw () ;
		arrow_down  -> Draw () ;
		
		start_game_dummy -> Draw () ;
		start_type_dummy -> Draw () ;
		network_dummy    -> Draw () ;
		editor_dummy     -> Draw () ;
		options_dummy    -> Draw () ;
		quit_dummy       -> Draw () ;
		
		new_game_text           -> Draw () ;
		continue_last_game_text -> Draw () ;
		load_game_text          -> Draw () ;
		erase_game_text         -> Draw () ;
		network_text            -> Draw () ;
		level_editor_text       -> Draw () ;
		options_text            -> Draw () ;
		quit_text               -> Draw () ;
		
		if ( pax_list -> Count () < 1 )
		{
			nopax_text              -> Draw () ;
			nopax_text_part1        -> Draw () ;
			nopax_text_part2        -> Draw () ;
			nopax_text_part3        -> Draw () ;
			nopax_text_part4        -> Draw () ;
			nopax_text_part5        -> Draw () ;
			
			if ( nopax_text_direction < 0 )
			{
				int x = nopax_text -> GetXPos () ;
				int y = nopax_text -> GetYPos () ;
				if ( x > -4959 )
					nopax_text -> SetDestXY ( -4959, y ) ;
				else
					nopax_text_direction = -nopax_text_direction ;
			}
			else
			{
				int x = nopax_text -> GetXPos () ;
				int y = nopax_text -> GetYPos () ;
				if ( x < video . GetScreenX () )
					nopax_text -> SetDestXY ( video . GetScreenX (), y ) ;
				else
					nopax_text_direction = -nopax_text_direction ;
			}
		}
		
		DrawPaxList () ;
	}
}

void Title::AfterDraw ()
{
	if ( quit_state == TRUE ) return ;

	if ( quit == TRUE && 
		background.GetIsQuitting () == FALSE ) 
	{
		background.Quit () ;
	}

	if ( quit == TRUE && background.GetIsDone () == TRUE )
	{	// set next pax...
		if ( pax_list -> Count () )
		{
			if ( pax_list -> Item ( pax_list_cur_item ) -> pathname != NULL )
				sprintf ( pkg_filename, "%s", 
							pax_list -> Item ( pax_list_cur_item ) -> pathname ) ;
			
			if ( next_game_screen == GS_GAME )
				if ( continue_last_game == false )
					fprintf ( stdout, "next pax will be: %s\n", pkg_filename ) ;
				else
					sprintf ( pkg_filename, "savestate:autosave" ) ;
		}
		
		// detach pax list and free user_data
		pax_list -> DetachList () ;
		
		// free the data...
		activate_sound . UnloadSound () ;
		
		arrow_left  -> Free () ; delete arrow_left  ;
		arrow_right -> Free () ; delete arrow_right ;
		arrow_up    -> Free () ; delete arrow_up    ;
		arrow_down  -> Free () ; delete arrow_down  ;
		
		new_game_text           -> Free () ; delete new_game_text           ;
		continue_last_game_text -> Free () ; delete continue_last_game_text ;
		load_game_text          -> Free () ; delete load_game_text          ;
		erase_game_text         -> Free () ; delete erase_game_text         ;
		network_text            -> Free () ; delete network_text            ;
		level_editor_text       -> Free () ; delete level_editor_text       ;
		options_text            -> Free () ; delete options_text            ;
		quit_text               -> Free () ; delete quit_text               ;
		nopax_text_part1        -> Free () ; delete nopax_text_part1        ;
		nopax_text_part2        -> Free () ; delete nopax_text_part2        ;
		nopax_text_part3        -> Free () ; delete nopax_text_part3        ;
		nopax_text_part4        -> Free () ; delete nopax_text_part4        ;
		nopax_text_part5        -> Free () ; delete nopax_text_part5        ;
		nopax_text              -> Free () ; delete nopax_text              ;
		
		start_game_dummy -> Free () ; delete start_game_dummy ;
		start_type_dummy -> Free () ; delete start_type_dummy ;
		network_dummy    -> Free () ; delete network_dummy    ;
		editor_dummy     -> Free () ; delete editor_dummy     ;
		options_dummy    -> Free () ; delete options_dummy    ;
		quit_dummy       -> Free () ; delete quit_dummy       ;
		
		dark_block -> Free () ; delete dark_block ;
		
		file_cache . FreeCachedData ( "vault", MiscVault ) ;
		file_cache . FreeCachedData ( "vault", MenuVault ) ;
		
		pax -> FreeObjects () ;
		delete pax ;
		
		quit_state = TRUE ;
	}
}

bool Title::IsQuitting ()
{
	return quit ;
}

bool Title::IsDone ()
{
	return quit_state ;
}

void Title::Quit ()
{
	quit = TRUE ;
	
	background.PrepareQuit () ;
	
	QuitPaxList () ;
	
	dark_block -> SetDestAlpha ( 0 ) ;
	
	arrow_left  -> SetDestAlpha ( 0 ) ;
	arrow_right -> SetDestAlpha ( 0 ) ;
	arrow_up    -> SetDestAlpha ( 0 ) ;
	arrow_down  -> SetDestAlpha ( 0 ) ;
	
	start_game_dummy -> SetDestAlpha ( 0 ) ;
	start_type_dummy -> SetDestAlpha ( 0 ) ;
	editor_dummy     -> SetDestAlpha ( 0 ) ;
	options_dummy    -> SetDestAlpha ( 0 ) ;
	quit_dummy       -> SetDestAlpha ( 0 ) ;
	
	if ( next_game_screen == GS_NONE )
		video . DisplayOSDMessage ( "quitting..." ) ;
	else
		video . DisplayOSDMessage ( "please wait..." ) ;
}

void Title::EnablePaxElement ( int element )
{
	if ( element < 0 || (unsigned int) element >= pax_list -> Count () ) return ;
	
	pax_list -> Item ( element ) -> border -> SetFrames ( AUTO, AUTO, -1, false, true ) ;
	if ( using_opengl )
		pax_list -> Item ( element ) -> border -> Glow ( true ) ;
	pax_list -> Item ( element ) -> node -> SetDestAlpha ( 255 ) ;
}

void Title::DisablePaxElement ( int element )
{
	if ( element < 0 || (unsigned int) element >= pax_list -> Count () ) return ;
	
	pax_list -> Item ( element ) -> border -> SetFrames ( AUTO, AUTO, 1, false, true ) ;
	if ( using_opengl )
		pax_list -> Item ( element ) -> border -> Glow ( false ) ;
	pax_list -> Item ( element ) -> node -> SetDestAlpha ( 128 ) ;
}

void Title::DrawPaxList ()
{
	for ( int pos = 0 ; (unsigned int) pos < pax_list -> Count () ; pos++ )
	{
		if ( pax_list_last_item != pax_list_cur_item )
		{
			DisablePaxElement ( pax_list_last_item ) ;
			EnablePaxElement  ( pax_list_cur_item ) ;
			
			// look if we've walked out of the screen...
			int rest = pax_list_cur_item % 3 ;
			int group = ( pax_list_cur_item - rest ) / 3 ;
			
			//fprintf ( stdout, "group = %d\n", group ) ;
			
			pax_list_offset = group ;
			
			//fprintf ( stdout, "cur item = %d ; last item = %d ; ",
			//			pax_list_cur_item, pax_list_last_item ) ;
			//fprintf ( stdout, "cur offset = %d ; last offset = %d\n",
			//			pax_list_offset, pax_list_old_offset ) ;
			
			if ( menu_line == ML_START_GAME )
			{
				if ( pax_list_last_item != -1 )
					activate_sound . PlaySound () ;
				
				if ( pax_list_offset > 0 )
					arrow_left -> SetDestAlpha ( 255 ) ;
				else
					arrow_left -> SetDestAlpha ( 0 ) ;
				
				if ( (unsigned int) pax_list_offset * 3 + 3 < pax_list -> Count () )
					arrow_right -> SetDestAlpha ( 255 ) ;
				else
					arrow_right -> SetDestAlpha ( 0 ) ;
			}
			
			if ( pax_list_offset != pax_list_old_offset )
			{
				int diff = max ( pax_list_offset, pax_list_old_offset ) -
							min ( pax_list_offset, pax_list_old_offset ) ;
				
				if ( pax_list_offset > pax_list_old_offset )
				{
					/*for ( unsigned int item = 0 ; item < pax_list . Count () ; item++ )
					{
						int screenx = video . GetScreenX () * diff ;
						int x = pax_list [ item ] . node -> GetXPos () - screenx ;
						int y = pax_list [ item ] . node -> GetYPos () ;
						
						pax_list [ item ] . node -> SetXY ( x, y ) ;
						pax_list [ item ] . node -> SlideInFrom ( screenx, 0 ) ;
					}*/
					int screenx = video . GetScreenX () * diff ;
					int x = start_game_dummy -> GetXPos () - screenx ;
					int y = start_game_dummy -> GetYPos () ;
					
					start_game_dummy -> SetXY ( x, y ) ;
					if ( menu_line == ML_START_GAME )
						start_game_dummy -> SlideInFrom ( screenx, 0 ) ;
				}
				else
				{
					/*for ( unsigned int item = 0 ; item < pax_list . Count () ; item++ )
					{
						int screenx = video . GetScreenX () * diff ;
						int x = pax_list [ item ] . node -> GetXPos () + screenx ;
						int y = pax_list [ item ] . node -> GetYPos () ;
						
						pax_list [ item ] . node -> SetXY ( x, y ) ;
						pax_list [ item ] . node -> SlideInFrom ( -screenx, 0 ) ;
					}*/
					int screenx = video . GetScreenX () * diff ;
					int x = start_game_dummy -> GetXPos () + screenx ;
					int y = start_game_dummy -> GetYPos () ;
					
					start_game_dummy -> SetXY ( x, y ) ;
					if ( menu_line == ML_START_GAME )
						start_game_dummy -> SlideInFrom ( -screenx, 0 ) ;
				}
				
				pax_list_old_offset = pax_list_offset ;
			}
			
			pax_list_last_item = pax_list_cur_item ;
		}
		
		pax_list -> Draw ( pos ) ;
		
		if ( menu_line != ML_START_GAME ) continue ;
		
		// from now on comes some cpu-intensive stuff.
		// due to its cpu-intensive scaling the effect will
		// only be visible with opengl-support...
		//if ( ! using_opengl ) continue ;
		// our new fps routine seems to even get this right :)
		// i've also added a hack for those things into the
		// sprite engine ( we don't have to do scaling when
		// not drawing those images to the screen, do we?! )
		
		Sprite *node = pax_list -> Item ( pos ) -> node ;
		KrSprite *sprite = node -> GetSprite () ;
		
		double *c_pos ;
		double *c_max ;
		double *d_pos ;
		double *d_max ;
		double *scale_x ;
		double *scale_y ;
		
		c_pos   = &( ( (pax_item_addon*) pax_list -> Item ( pos ) -> user_data ) -> c_pos   ) ;
		c_max   = &( ( (pax_item_addon*) pax_list -> Item ( pos ) -> user_data ) -> c_max   ) ;
		d_pos   = &( ( (pax_item_addon*) pax_list -> Item ( pos ) -> user_data ) -> d_pos   ) ;
		d_max   = &( ( (pax_item_addon*) pax_list -> Item ( pos ) -> user_data ) -> d_max   ) ;
		scale_x = &( ( (pax_item_addon*) pax_list -> Item ( pos ) -> user_data ) -> scale_x ) ;
		scale_y = &( ( (pax_item_addon*) pax_list -> Item ( pos ) -> user_data ) -> scale_y ) ;
		
		if ( *d_pos >= *d_max )
		{
			*d_pos = 0 ;
			
			double x_scale = 1.00, y_scale = 1.00 ;
			
			double x_step = 0.50 / (*c_max) ;
			double y_step = 0.50 / (*c_max) ;
			
			double x_pos  = node -> GetXPos () ;
			double y_pos  = node -> GetYPos () ;
			double width  = pax_list -> Item ( pos ) -> border -> GetWidth  () ;
			double height = pax_list -> Item ( pos ) -> border -> GetHeight () ;
			
			if ( (*c_pos) < (*c_max) / 2 )
			{
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_x < 1.00 )
					x_scale = 1.00 + ( (*c_pos) * x_step ) ;
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_y > 1.00 )
					y_scale = 1.00 + ( ( ( (*c_max) ) - (*c_pos) ) * y_step ) ;
				
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_x < 1.00 )
					x_pos -= ( (width  * x_scale) - width  ) / 2.00 ;
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_y > 1.00 )
					y_pos -= ( (height * y_scale) - height ) / 2.00 ;
			}
			else
			{
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_x > 1.00 )
					x_scale = 1.00 + ( ( ( (*c_max) ) - (*c_pos) ) * x_step ) ;
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_y < 1.00 )
					y_scale = 1.00 + ( (*c_pos) * y_step ) ;
				
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_x > 1.00 )
					x_pos -= ( (width  * x_scale) - width  ) / 2.00 ;
				if ( pax_list_cur_item == pos ||
						pax_list_cur_item != pos && *scale_y < 1.00 )
					y_pos -= ( (height * y_scale) - height ) / 2.00 ;
			}
			
			KrSpriteResource *res = sprite -> SpriteResource () ;
			if ( ! res -> IsScaleCached ( x_scale, y_scale ) )
				 res -> CacheScale ( x_scale, y_scale ) ;
			
			if ( *scale_x != x_scale || *scale_y != y_scale )
			{
				*scale_x = x_scale ;
				*scale_y = y_scale ;
				if ( video . GetFramesLeft () == 0 )
				{
					sprite -> SetScale ( x_scale, y_scale ) ;
					sprite -> SetPos ( (int) x_pos, (int) y_pos ) ;
				}
			}
			
			if ( *c_pos >= *c_max )
				*c_pos = 0 ;
			else
				(*c_pos) ++ ;
		}
		else
			(*d_pos) ++ ;
	}
}

void Title::ShowPaxList ()
{
	// look if we've walked out of the screen...
	int rest = pax_list_cur_item % 3 ;
	int group = ( pax_list_cur_item - rest ) / 3 ;
	
	//fprintf ( stdout, "group = %d\n", group ) ;
	
	pax_list_offset = group ;
	
	//fprintf ( stdout, "cur item = %d ; last item = %d ; ",
	//			pax_list_cur_item, pax_list_last_item ) ;
	//fprintf ( stdout, "cur offset = %d ; last offset = %d\n",
	//			pax_list_offset, pax_list_old_offset ) ;
	
	activate_sound . PlaySound () ;
	
	if ( pax_list_offset > 0 )
		arrow_left -> SetDestAlpha ( 255 ) ;
	else
		arrow_left -> SetDestAlpha ( 0 ) ;
	
	if ( (unsigned int) pax_list_offset * 3 + 3 < pax_list -> Count () )
		arrow_right -> SetDestAlpha ( 255 ) ;
	else
		arrow_right -> SetDestAlpha ( 0 ) ;
	
	start_game_dummy -> SetDestAlpha ( 255 ) ;
}

void Title::HidePaxList ()
{
	start_game_dummy -> SetDestAlpha ( 0 ) ;
	arrow_left  -> SetDestAlpha ( 0 ) ;
	arrow_right -> SetDestAlpha ( 0 ) ;
}

void Title::QuitPaxList ()
{
	for ( unsigned int pos = 0 ; pos < pax_list -> Count () ; pos++ )
	{
		pax_list -> Item ( pos ) -> node -> SetDestAlpha ( 0 ) ;
		pax_list -> Item ( pos ) -> screenshot -> SetDestAlpha ( 0 ) ;
		pax_list -> Item ( pos ) -> border -> SetDestAlpha ( 0 ) ;
	}
}
